
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#ifndef _DATABASE_MANAGER_H_
#define _DATABASE_MANAGER_H_

#include <QtCore/QObject>

#include <QtSql/QSqlDatabase>

class ImageInfos;

class DatabaseManager : public QObject
{
    Q_OBJECT

public:

    DatabaseManager(QObject *parent = 0);
    virtual ~DatabaseManager();

    bool isValid() const;

    void retrieveInfos(ImageInfos *infos);
    void storeInfos(ImageInfos *infos);
    void removeInfos(const QString &);

    //! Delete and reinit current database
    void clearDB();

private:

    void init();
    bool initDB();
    bool createDB();
    bool openDB();

    QString m_database;
    QSqlDatabase m_db;
    bool m_valid;
    QString m_driverName;
};

#endif // _DATABASE_MANAGER_H_
