
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#include <QtGui/QApplication>
#include <QtGui/QPainter>

#include "IconViewDelegate.h"

IconViewDelegate::IconViewDelegate(QObject * parent) : QStyledItemDelegate(parent)
{
}

IconViewDelegate::~IconViewDelegate()
{
}

// Define item size in listview.
QSize IconViewDelegate::sizeHint(const               QStyleOptionViewItem & /*option*/,
                                 const QModelIndex & index) const
{
    QPixmap pix = qvariant_cast<QPixmap>( index.data(Qt::DecorationRole) );
    QSize iconsize = pix.size();

    //QSize iconsize = option.decorationSize;
    QFont font = QApplication::font();
    QFontMetrics fm(font);

    return( QSize(iconsize.width(),iconsize.height() + 2 * fm.height() + 8 ) );
}
