
/******************************************************************************
   SyncWall: Wallpaper manager
   Copyright(C) 2011-2013  xbee@xbee.net

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *******************************************************************************/

#ifndef _SCHEDULERCONFIGWIDGET_H_
#define _SCHEDULERCONFIGWIDGET_H_

#include <QtCore/QTime>

#include <QtGui/QWidget>

#include "Scheduler.h"

namespace Ui
{
class SchedulerConfigWidgetClass;
}

class SchedulerConfigWidget : public QWidget
{
    Q_OBJECT

public:

    explicit SchedulerConfigWidget(QWidget *parent = 0);
    ~SchedulerConfigWidget();

    void start() {m_scheduler.start(); }

    bool getIntervalBetweenChangeMode() const {return m_scheduler.getIntervalBetweenChangeMode(); }

    void restartScheduler() {m_scheduler.restartScheduler(); }

    void stopQuitAfterChange() {m_scheduler.stopQuitAfterChange(); }

public slots:

    void on_checkBoxStartup_stateChanged ( int );
    void on_checkBoxStartupAndQuit_stateChanged ( int );
    void on_groupBoxFrequency_clicked(bool);
    void on_radioButtonInterval_toggled(bool);
    void on_radioButtonTimeOfDay_toggled(bool);

    void on_timeEditInterval_timeChanged(const QTime & time);

    void on_pushButtonAddTOD_pressed();
    void on_pushButtonDeleteTOD_pressed();

    void setIdle(bool);

    void saveSettings();

signals:

    void newState();
    void newEvent();
    void quit();

private:

    void rebuildTODList();
    void updateUI();

    Ui::SchedulerConfigWidgetClass *ui;

    Scheduler m_scheduler;
};

#endif // _SCHEDULERCONFIGWIDGET_H_
